// fichier : bitwise.cc
// version : 1.0
// 

#include <iostream>

using namespace std;

constexpr unsigned mask5(31);
constexpr unsigned shift(9);

int main(void)
{
	// difficile de savoir la valeur du groupe G de 5 bits 
	// entre les puissances 9 et 14 pour l'entier n :
	unsigned n(1234567); 
	
	cout << "Valeur entière du mot contenant le groupe G de 5 bits : ";
	cout << n << endl;
	
	// décalage qui ramène le groupe G sur les poids faibles
	n >>= shift ; 
	
	// cependant il faut se débarasser des poids au-dessus de 4
	// car d'autres données occupent ces bits
	cout << "Valeur entière après décalage du groupe G sur les poids faibles : ";
	cout << n << endl;
	
	// tous les bits au dessus de la puissance 4 passent à 0
	n &= mask5 ;
	
	// il ne reste que la valeur de notre groupe G de 5 bits
	cout << "Valeur entière après décalage et masquage: ";
	cout << n << endl;
	
	return 0;
}
